%global     snapdate        20130611
%global     revision        da70025
%global     alphatag        %{snapdate}git%{revision}
%global     vimfiles        %{_datadir}/vim/vim.vimfiles

# The source for this package was pulled from upstream's git.
# Use the following commands to generate the tarball:
# cd syntastic;
# git clone git://github.com/scrooloose/syntastic.git
# pushd syntastic
# git rev-parse --short HEAD # -> syntastic_rev
# git checkout %%syntastic_rev
# git archive --prefix=syntastic-%%{alphatag}/ HEAD --format=tar | xz > ../syntastic-%%{alphatag}.tar.xz
# popd

Name:           syntastic
Version:        2.3.0
Release:        12.%{alphatag}%{?dist}
Summary:        A/A.vim plugins to check syntax for programming languages
Summary(fr):    Une extension de/de.vim vérifiant la syntaxe pour les langages de programmation

License:        WTFPL
URL:            https://github.com/scrooloose/syntastic
Source0:        %{name}-%{alphatag}.tar.xz
Patch0:         %{name}.patch

BuildArch:      noarch
Requires:       vim
BuildRequires:  glibc-common

%description
Syntastic is a syntax checking plugin that runs files through external syntax
checkers and displays any resulting errors to the user. This can be done on
demand, or automatically as files are saved. If syntax errors are detected, the
user is notified and is happy because they didn't have to compile their code or
execute their script to find them.

%description -l fr
Syntastic est une extension vérifiant la syntaxe des fichiers source, un outil
externe de vérification affiche toutes les erreurs trouvées à l'utilisateur.
Ceci peut être fait à la demande ou automatique au moment de la sauvegarde
du fichier. Si une erreur de syntaxe est détecté, les utilisateurs sont
informés et sont heureux de ne pas avoir compiler leur code ou d'avoir
exécuter leur script afin de les trouver.

%define add_subpackage(n:)                                                          \
%package %{-n*}                                                                     \
Summary:        A syntax checker for %{-n*} programming language                    \
Summary(fr):    Un vérificateur de syntaxe pour le langage de programmation %{-n*}  \
Requires:       %{name} =  %{version}-%{release}                                    \
Requires:       %*                                                                  \
%description %{-n*}                                                                 \
Allows checking %{-n*} sources files.                                               \
%description -l fr %{-n*}                                                           \
Permet de vérifier les fichiers sources écrit en %{-n*}.                            \
%{nil}


%define install_subpackage()                                                      \
install -p -d %{buildroot}%{vimfiles}/syntax_checkers/%1/                         \
install -D syntax_checkers/%1/* %{buildroot}%{vimfiles}/syntax_checkers/%1/       \
%{nil}

%add_subpackage -n ada gcc-gnat
%add_subpackage -n c gcc
%add_subpackage -n cpp gcc-c++
%add_subpackage -n cs mono-core
%add_subpackage -n css csslint
%add_subpackage -n coffee coffee-script
%add_subpackage -n coq coq
%add_subpackage -n cucumber rubygem-cucumber
%add_subpackage -n docbk libxml2
%add_subpackage -n d ldc
%add_subpackage -n elixir elixir
%add_subpackage -n erlang erlang-erts
%add_subpackage -n eruby ruby
%add_subpackage -n fortran gcc-gfortran
%add_subpackage -n gentoo-metadata libxml2
%add_subpackage -n haml rubygem-haml
%add_subpackage -n haskell ghc
%add_subpackage -n html sed curl tidy
# javac into devel package (java-1.7.0-openjdk-devel)
%add_subpackage -n java java-1.7.0-openjdk-devel
%add_subpackage -n javascript jsl
%add_subpackage -n json python-demjson
%add_subpackage -n less lessjs
%add_subpackage -n lisp clisp
%add_subpackage -n llvm llvm
%add_subpackage -n lua lua
%add_subpackage -n nasm nasm
%add_subpackage -n ocaml ocaml
%add_subpackage -n objc gcc-objc gcc-objc++
%add_subpackage -n perl perl
%add_subpackage -n php php
%add_subpackage -n puppet puppet
%add_subpackage -n python pylint pyflakes
%add_subpackage -n rst python-docutils
%add_subpackage -n ruby ruby
%add_subpackage -n scss rubygem-sass
%add_subpackage -n sass rubygem-sass
%add_subpackage -n scala scala
%add_subpackage -n slim rubygem-slim
%add_subpackage -n sh bash
%add_subpackage -n tcl tcl
%add_subpackage -n tex texlive-latex
%add_subpackage -n vala vala
%add_subpackage -n vhdl ghdl
%add_subpackage -n xhtml tidy
# xmllint into lib package (libxml2)
%add_subpackage -n xml libxml2
%add_subpackage -n xslt libxml2
%add_subpackage -n zsh zsh

%prep
%setup  -q -n %{name}-%{alphatag}
%patch0 -p1 -b .fix
# fix script mode
chmod 644 syntax_checkers/perl/efm_perl.pl
iconv -f LATIN1 -t UTF-8 syntax_checkers/perl/efm_perl.pl -o syntax_checkers/efm_perl.pl

%build

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{vimfiles}/autoload
mkdir -p %{buildroot}%{vimfiles}/syntax_checkers
mkdir -p %{buildroot}%{vimfiles}/doc/
mkdir -p %{buildroot}%{vimfiles}/plugin/syntastic/

cp      -rp       autoload/*            %{buildroot}%{vimfiles}/autoload
install -p -m0644 doc/syntastic.txt     %{buildroot}%{vimfiles}/doc/syntastic.txt
install -p -m0644 plugin/syntastic.vim  %{buildroot}%{vimfiles}/plugin/syntastic.vim
install -D plugin/syntastic/*           %{buildroot}%{vimfiles}/plugin/syntastic/
%install_subpackage  ada
#%%install_subpackage  applescript
%install_subpackage  c
%install_subpackage  coq
%install_subpackage  coffee
%install_subpackage  coq
%install_subpackage  cpp
%install_subpackage  cs
%install_subpackage  css
%install_subpackage  cucumber
#%%install_subpackage  cuda
%install_subpackage  d
#%%install_subpackage  dart
%install_subpackage  docbk
%install_subpackage  elixir
%install_subpackage  erlang
%install_subpackage  eruby
%install_subpackage  fortran
%install_subpackage  gentoo_metadata
#%%install_subpackage  go
%install_subpackage  haml
%install_subpackage  haskell
#%%install_subpackage  haxe
%install_subpackage  html
%install_subpackage  java
%install_subpackage  javascript
%install_subpackage  json
%install_subpackage  less
%install_subpackage  lisp
%install_subpackage  llvm
%install_subpackage  lua
#%%install_subpackage  matlab
%install_subpackage  nasm
%install_subpackage  objc
%install_subpackage  ocaml
%install_subpackage  perl
%install_subpackage  php
%install_subpackage  puppet
%install_subpackage  python
%install_subpackage  rst
%install_subpackage  ruby
#%%install_subpackage  rust
%install_subpackage  sass
%install_subpackage  scala
%install_subpackage  scss
%install_subpackage  sh
%install_subpackage  slim
%install_subpackage  tcl
%install_subpackage  tex
#%%install_subpackage  twig
#%%install_subpackage  typescript
%install_subpackage  vala
%install_subpackage  vhdl
%install_subpackage  xhtml
%install_subpackage  xml
%install_subpackage  xslt
#%%install_subpackage  yaml
#%%install_subpackage  z80
#%%install_subpackage  zpt
%install_subpackage  zsh


# not install -dep :
# applescript/applescript.vim   -> mac os
# cuda/cuda.vim                 -> no nvcss executable in repo
# go/go.vim and go dir          -> no go executable in repo
# haxe/haxe.vim                 -> no haxe executable in repo
# matlab/matlab.vim             -> no mlint executable in repo
# yaml/yaml.vim                 -> no js-yaml executable in repo
# z80.vim                       -> no 80_syntax_checker.pyt executable in repo
# zpt/zpt.vim                   -> no zptlint executable in repo
# elixir                        -> no elixir executable in repo

%post
umask 022
cd %{vimfiles}/doc
vim -u NONE -esX -c "helptags ." -c quit
exit 0


%postun
if [ $1 -eq 0 ]; then
umask 022
cd %{vimfiles}/doc
>tags
vim -u NONE -esX -c "helptags ." -c quit
fi
exit 0

%files
%doc _assets/screenshot_1.png README.markdown LICENCE
%{vimfiles}/plugin/syntastic.vim
%{vimfiles}/plugin/syntastic/autoloclist.vim
%{vimfiles}/plugin/syntastic/balloons.vim
%{vimfiles}/plugin/syntastic/checker.vim
%{vimfiles}/plugin/syntastic/cursor.vim
%{vimfiles}/plugin/syntastic/highlighting.vim
%{vimfiles}/plugin/syntastic/loclist.vim
%{vimfiles}/plugin/syntastic/makeprg_builder.vim
%{vimfiles}/plugin/syntastic/modemap.vim
%{vimfiles}/plugin/syntastic/notifiers.vim
%{vimfiles}/plugin/syntastic/registry.vim
%{vimfiles}/plugin/syntastic/signs.vim
%{vimfiles}/doc/syntastic.txt
%dir %{vimfiles}/syntax_checkers/
%dir %{vimfiles}/autoload/syntastic/
%{vimfiles}/autoload/syntastic/c.vim
%{vimfiles}/autoload/syntastic/makeprg.vim
%{vimfiles}/autoload/syntastic/postprocess.vim
%{vimfiles}/autoload/syntastic/util.vim


%files ada
%dir %{vimfiles}/syntax_checkers/ada
%{vimfiles}/syntax_checkers/ada/gcc.vim

#%%files applescript
#%%dir applescript
#%%{vimfiles}/syntax_checkers/applescript/osacompile.vim

%files c
%dir %{vimfiles}/syntax_checkers/c
%{vimfiles}/syntax_checkers/c/make.vim
%{vimfiles}/syntax_checkers/c/checkpatch.vim
%{vimfiles}/syntax_checkers/c/gcc.vim
%{vimfiles}/syntax_checkers/c/splint.vim
%{vimfiles}/syntax_checkers/c/sparse.vim
%{vimfiles}/syntax_checkers/c/ycm.vim
%{vimfiles}/syntax_checkers/c/oclint.vim

%files coq
%dir %{vimfiles}/syntax_checkers/co
%{vimfiles}/syntax_checkers/co/coco.vim

%files coffee
%dir %{vimfiles}/syntax_checkers/coffee
%{vimfiles}/syntax_checkers/coffee/coffee.vim
%{vimfiles}/syntax_checkers/coffee/coffeelint.vim

%files coq
%dir %{vimfiles}/syntax_checkers/coq
%{vimfiles}/syntax_checkers/coq/coqtop.vim

%files cpp
%dir %{vimfiles}/syntax_checkers/cpp
%{vimfiles}/syntax_checkers/cpp/cpplint.vim
%{vimfiles}/syntax_checkers/cpp/gcc.vim
%{vimfiles}/syntax_checkers/cpp/ycm.vim
%{vimfiles}/syntax_checkers/cpp/oclint.vim

%files cs
%dir %{vimfiles}/syntax_checkers/cs
%{vimfiles}/syntax_checkers/cs/mcs.vim

%files css
%dir %{vimfiles}/syntax_checkers/css
%{vimfiles}/syntax_checkers/css/prettycss.vim
%{vimfiles}/syntax_checkers/css/phpcs.vim
%{vimfiles}/syntax_checkers/css/csslint.vim

%files cucumber
%dir %{vimfiles}/syntax_checkers/cucumber
%{vimfiles}/syntax_checkers/cucumber/cucumber.vim

#%%files cuda
#%%dir cuda
#%%{vimfiles}/syntax_checkers/cuda/nvcc.vim

%files d
%dir %{vimfiles}/syntax_checkers/d
%{vimfiles}/syntax_checkers/d/dmd.vim
%{vimfiles}/syntax_checkers/d/dmd.vim.fix

#%%files dart
#%%dir %{vimfiles}/syntax_checkers/dart
#%%{vimfiles}/syntax_checkers/dart/dart_analyzer.vim

%files docbk
%dir %{vimfiles}/syntax_checkers/docbk
%{vimfiles}/syntax_checkers/docbk/xmllint.vim

%files elixir
%dir %{vimfiles}/syntax_checkers/elixir
%{vimfiles}/syntax_checkers/elixir/elixir.vim

%files erlang
%dir %{vimfiles}/syntax_checkers/erlang
%{vimfiles}/syntax_checkers/erlang/erlang_check_file.erl
%{vimfiles}/syntax_checkers/erlang/erlang.vim

%files eruby
%dir %{vimfiles}/syntax_checkers/eruby
%{vimfiles}/syntax_checkers/eruby/ruby.vim

%files fortran
%dir %{vimfiles}/syntax_checkers/fortran
%{vimfiles}/syntax_checkers/fortran/gfortran.vim

%files gentoo-metadata
%dir %{vimfiles}/syntax_checkers/gentoo_metadata
%{vimfiles}/syntax_checkers/gentoo_metadata/xmllint.vim

#%%files go
#%%dir go
#%%{vimfiles}/syntax_checkers/go/govet.vim
#%%{vimfiles}/syntax_checkers/go/gofmt.vim
#%%{vimfiles}/syntax_checkers/go/go.vim

%files haml
%dir %{vimfiles}/syntax_checkers/haml
%{vimfiles}/syntax_checkers/haml/haml.vim

%files haskell
%dir %{vimfiles}/syntax_checkers/haskell
%{vimfiles}/syntax_checkers/haskell/ghc-mod.vim
%{vimfiles}/syntax_checkers/haskell/hdevtools.vim

#%%files haxe
#%%dir %{vimfiles}/syntax_checkers/haxe
#%%{vimfiles}/syntax_checkers/haxe/haxe.vim

%files html
%dir %{vimfiles}/syntax_checkers/html
%{vimfiles}/syntax_checkers/html/validator_decode.awk
%{vimfiles}/syntax_checkers/html/validator.vim
%{vimfiles}/syntax_checkers/html/tidy.vim
%{vimfiles}/syntax_checkers/html/w3.vim

%files java
%dir %{vimfiles}/syntax_checkers/java
%{vimfiles}/syntax_checkers/java/checkstyle.vim
%{vimfiles}/syntax_checkers/java/javac.vim

%files javascript
%dir %{vimfiles}/syntax_checkers/javascript
%{vimfiles}/syntax_checkers/javascript/gjslint.vim
%{vimfiles}/syntax_checkers/javascript/jsl.vim
%{vimfiles}/syntax_checkers/javascript/jslint.vim
%{vimfiles}/syntax_checkers/javascript/jshint.vim
%{vimfiles}/syntax_checkers/javascript/closurecompiler.vim

%files json
%dir %{vimfiles}/syntax_checkers/json
%{vimfiles}/syntax_checkers/json/jsonlint.vim
%{vimfiles}/syntax_checkers/json/jsonval.vim

%files less
%dir %{vimfiles}/syntax_checkers/less
%{vimfiles}/syntax_checkers/less/lessc.vim
%{vimfiles}/syntax_checkers/less/less-lint.js
%{vimfiles}/syntax_checkers/less/less-lint.coffee

%files lisp
%dir %{vimfiles}/syntax_checkers/lisp
%{vimfiles}/syntax_checkers/lisp/clisp.vim

%files llvm
%dir %{vimfiles}/syntax_checkers/llvm
%{vimfiles}/syntax_checkers/llvm/llvm.vim

%files lua
%dir %{vimfiles}/syntax_checkers/lua
%{vimfiles}/syntax_checkers/lua/luac.vim

#%%files matlab
#%%dir %{vimfiles}/syntax_checkers/matlab
#%%{vimfiles}/syntax_checkers/matlab/mlint.vim

%files nasm
%dir %{vimfiles}/syntax_checkers/nasm
%{vimfiles}/syntax_checkers/nasm/nasm.vim

%files objc
%dir %{vimfiles}/syntax_checkers/objc
%{vimfiles}/syntax_checkers/objc/gcc.vim
%{vimfiles}/syntax_checkers/objc/ycm.vim
%{vimfiles}/syntax_checkers/objc/oclint.vim

%files ocaml
%dir %{vimfiles}/syntax_checkers/ocaml
%{vimfiles}/syntax_checkers/ocaml/camlp4o.vim

%files perl
%dir %{vimfiles}/syntax_checkers/perl
%{vimfiles}/syntax_checkers/perl/efm_perl.pl
%{vimfiles}/syntax_checkers/perl/perl.vim
%{vimfiles}/syntax_checkers/perl/perlcritic.vim
%{vimfiles}/syntax_checkers/perl/podchecker.vim

%files php
%dir %{vimfiles}/syntax_checkers/php
%{vimfiles}/syntax_checkers/php/phpcs.vim
%{vimfiles}/syntax_checkers/php/phpmd.vim
%{vimfiles}/syntax_checkers/php/php.vim

%files puppet
%dir %{vimfiles}/syntax_checkers/puppet
%{vimfiles}/syntax_checkers/puppet/puppetlint.vim

%files python
%dir %{vimfiles}/syntax_checkers/python
%{vimfiles}/syntax_checkers/python/pep8.vim
%{vimfiles}/syntax_checkers/python/python.vim
%{vimfiles}/syntax_checkers/python/py3kwarn.vim
%{vimfiles}/syntax_checkers/python/pylint.vim
%{vimfiles}/syntax_checkers/python/flake8.vim
%{vimfiles}/syntax_checkers/python/pyflakes.vim

%files rst
%dir %{vimfiles}/syntax_checkers/rst
%{vimfiles}/syntax_checkers/rst/rst2pseudoxml.vim

%files ruby
%dir %{vimfiles}/syntax_checkers/ruby
%{vimfiles}/syntax_checkers/ruby/macruby.vim
%{vimfiles}/syntax_checkers/ruby/rubocop.vim
%{vimfiles}/syntax_checkers/ruby/mri.vim
%{vimfiles}/syntax_checkers/ruby/jruby.vim

#%%files rust
#%%dir %{vimfiles}/syntax_checkers/rust
#%%{vimfiles}/syntax_checkers/rust/rustc.vim

%files sass
%dir %{vimfiles}/syntax_checkers/sass
%{vimfiles}/syntax_checkers/sass/sass.vim

%files scala
%dir %{vimfiles}/syntax_checkers/scala
%{vimfiles}/syntax_checkers/scala/scalac.vim

%files scss
%dir %{vimfiles}/syntax_checkers/scss
%{vimfiles}/syntax_checkers/scss/sass.vim

%files sh
%dir %{vimfiles}/syntax_checkers/sh
%{vimfiles}/syntax_checkers/sh/sh.vim
%{vimfiles}/syntax_checkers/sh/checkbashisms.vim

%files slim
%dir %{vimfiles}/syntax_checkers/slim
%{vimfiles}/syntax_checkers/slim/slimrb.vim

%files tcl
%dir %{vimfiles}/syntax_checkers/tcl
%{vimfiles}/syntax_checkers/tcl/nagelfar.vim

%files tex
%dir %{vimfiles}/syntax_checkers/tex
%{vimfiles}/syntax_checkers/tex/chktex.vim
%{vimfiles}/syntax_checkers/tex/lacheck.vim

#%%files twig
#%%dir %{vimfiles}/syntax_checkers/twig
#%%{vimfiles}/syntax_checkers/twig/twiglint.vim

#%%files typescript
#%%dir typescript
#%%{vimfiles}/syntax_checkers/typescript/tsc.vim

%files vala
%dir %{vimfiles}/syntax_checkers/vala
%{vimfiles}/syntax_checkers/vala/valac.vim

%files vhdl
%dir %{vimfiles}/syntax_checkers/vhdl
%{vimfiles}/syntax_checkers/vhdl/ghdl.vim

%files xhtml
%dir %{vimfiles}/syntax_checkers/xhtml
%{vimfiles}/syntax_checkers/xhtml/tidy.vim

%files xml
%dir %{vimfiles}/syntax_checkers/xml
%{vimfiles}/syntax_checkers/xml/xmllint.vim

%files xslt
%dir %{vimfiles}/syntax_checkers/xslt
%{vimfiles}/syntax_checkers/xslt/xmllint.vim

#%%files yaml
#%%dir %{vimfiles}/syntax_checkers/yaml
#%%{vimfiles}/syntax_checkers/yaml/jsyaml.vim

#%%files z80
#%%dir %{vimfiles}/syntax_checkers/z80
#%%{vimfiles}/syntax_checkers/z80/z80syntaxchecker.vim

#%%files zpt
#%%dir %{vimfiles}/syntax_checkers/zpt
#%%{vimfiles}/syntax_checkers/zpt/zptlint.vim

%files zsh
%dir %{vimfiles}/syntax_checkers/zsh
%{vimfiles}/syntax_checkers/zsh/zsh.vim




%changelog
* Tue Jun 11 2013 Jonathan MERCIER <bioinfornatics at fedoraproject dot org> - 2.3.0-12.20130611gitda70025
- Update to rev da70025

* Mon Jun 10 2013 Jonathan MERCIER <bioinfornatics at fedoraproject dot org> - 2.3.0-11.20130610git6574872
- Update to rev 6574872

* Fri May 24 2013 Jonathan MERCIER <bioinfornatics at fedoraproject dot org> - 2.3.0-10.20130523gita97e01a
- Update to rev a97e01a

* Sun May 19 2013 Jonathan MERCIER <bioinfornatics at fedoraproject dot org> - 2.3.0-9.20130517gitc7ad55c
- Update to rev c7ad55c

* Wed Oct 03 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-8.20120917git72856e6
- fix spec

* Thu Sep 27 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-7.20120917git72856e6
- fix spec file

* Wed Sep 26 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-6.20120917git72856e6
- fix spec file

* Wed Sep 26 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-5.20120917git72856e6
- put  inautoload/syntastic/c/c.vimto c subpackage

* Mon Sep 17 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-4.20120917git72856e6
- Update to latest rev

* Thu Aug 23 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-3.20120802gite5dfcc3
- fix License
- remove unused macro
- Fix dependecies

* Mon Jun 18 2012  Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-2.20120617git1e94b98
- Update spec file

* Sun Jun 17 2012  Jonathan MERCIER <bioinfornatics at gmail.com> - 2.3.0-1.20120617git1e94b98
- initial release
